"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _utils = require("../utils");

var _visitorManager = _interopRequireDefault(require("../visitorManager"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var RootModel =
/*#__PURE__*/
function () {
  function RootModel(attrs, children) {
    var _this = this;

    _classCallCheck(this, RootModel);

    _defineProperty(this, "items", void 0);

    _defineProperty(this, "keyName", void 0);

    _defineProperty(this, "dict", void 0);

    _defineProperty(this, "schema", void 0);

    _defineProperty(this, "pageSchema", void 0);

    _defineProperty(this, "connector", void 0);

    _defineProperty(this, "resolvers", void 0);

    _defineProperty(this, "visitors", void 0);

    _defineProperty(this, "entry", void 0);

    _defineProperty(this, "imageStorages", void 0);

    _defineProperty(this, "fileStorages", void 0);

    _defineProperty(this, "graphqlClient", void 0);

    var dataSchema = children.slice().filter(function (child) {
      return child.type === 'object' || child.type === 'array';
    }).reduce(function (result, child) {
      if (child.keyName in result) {
        throw new Error("Schema Error: duplicated name in children of ".concat(_this.keyName));
      }

      if (child.type === 'array' && !child.toolbar) {
        // default pagination in first array
        child.toolbar = {
          pagination: {}
        };
      }

      result[child.keyName] = child;
      return result;
    }, {});
    var pageSchema = children.filter(function (child) {
      return child.type === 'page';
    }).reduce(function (result, child) {
      result[child.keyName] = child;
      return result;
    }, {});
    this.dict = attrs.dict || {};
    this.schema = dataSchema;
    this.pageSchema = pageSchema;
    this.visitors = _visitorManager.default.getAllVisitors();
    this.imageStorages = (0, _utils.genStorages)(attrs, children, 'imageStorage');
    this.fileStorages = (0, _utils.genStorages)(attrs, children, 'fileStorage');
    this.resolvers = (0, _utils.parseResolvers)(attrs, children);
    this.connector = (0, _utils.parseConnector)(attrs, children) || (0, _utils.parseConnector)(attrs, children);
    this.graphqlClient = (0, _utils.parseGraphqlClient)(attrs, children) || (0, _utils.parseGraphqlClients)(attrs, children);
  }

  _createClass(RootModel, [{
    key: "toJson",
    value: function toJson() {
      return {
        dict: this.dict,
        schema: this.schema,
        pageSchema: this.pageSchema,
        visitors: this.visitors,
        imageStorages: this.imageStorages,
        fileStorages: this.fileStorages,
        resolvers: this.resolvers,
        connector: this.connector,
        graphqlClient: this.graphqlClient
      };
    }
  }]);

  return RootModel;
}();

exports.default = RootModel;